/*
 *	exec_ts2aac Ver.0.00	Copyright (C) 2009  kt
 *
 *	ts2aac  fprnhook.dll 𒍓ċNB
 *
 *	usage:
 *	  exec_ts2aac <ts2aac_path> [<param>]
 */

#define _UNICODE
#define UNICODE
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#define DLL_NAME	L"fprnhook.dll"

// fprintf() tbNp DLL 𒍓
void InjectDll(HANDLE hProcess)
{
	TCHAR buf[MAX_PATH];
	void *szDllRemote;
	HANDLE hThread = NULL;
	PTHREAD_START_ROUTINE pfnLoadLibrary;
	int cb, len;
	
	GetModuleFileName(NULL, buf, MAX_PATH);
//OutputDebugString(buf);
	len = lstrlen(buf);
	while (--len >= 0) {
		if (buf[len] == '\\') {
			break;
		}
	}
	lstrcpy(buf + len + 1, DLL_NAME);
	cb = (lstrlen(buf) + 1) * sizeof(TCHAR);
//OutputDebugString(buf);
	
	szDllRemote = VirtualAllocEx(hProcess, NULL, cb, MEM_COMMIT, PAGE_READWRITE);
	if (szDllRemote == NULL) {
		goto end;
	}
	
	if (!WriteProcessMemory(hProcess, szDllRemote, buf, cb, NULL)) {
		goto end;
	}
	
	pfnLoadLibrary = (PTHREAD_START_ROUTINE)
			GetProcAddress(GetModuleHandle(TEXT("kernel32")), "LoadLibraryW");
	if (pfnLoadLibrary == NULL) {
		goto end;
	}
	
	hThread = CreateRemoteThread(hProcess, NULL, 0,
			pfnLoadLibrary, szDllRemote, 0, NULL);
	if (hThread == NULL) {
		goto end;
	}
	
	WaitForSingleObject(hThread, INFINITE);
//OutputDebugString(TEXT("InjectDll() ok\n"));
	
end:
	if (szDllRemote != NULL) {
		VirtualFreeEx(hProcess, szDllRemote, 0, MEM_RELEASE);
	}
	if (hThread != NULL) {
		CloseHandle(hThread);
	}
}

int __cdecl main()
{
	PTBYTE lpszCommandLine;
	PROCESS_INFORMATION pi;
	STARTUPINFO si = {sizeof(si)};
	BOOL ret;
	DWORD exitcode;
	
	lpszCommandLine = (PTBYTE) GetCommandLine();
	
	// Skip past program name (first token in command line)
	
	// Check for and handle quoted program name
	if (*lpszCommandLine == '"') {
		// Scan, and skip over, subsequent characters until another
		// double-quote or a null is encountered
		do {
			lpszCommandLine++;
		} while (*lpszCommandLine && (*lpszCommandLine != '"'));
		
		// If we stopped on a double-quote (usual case), skip over it.
		if (*lpszCommandLine == '"')
			lpszCommandLine++;
	} else {
		// First token wasn't a quote
		while (*lpszCommandLine > ' ')
			lpszCommandLine++;
	}
	
	// skip past any white space preceeding the second token.
	while (*lpszCommandLine && (*lpszCommandLine <= ' '))
		lpszCommandLine++;
	
	
//OutputDebugString(lpszCommandLine);
	ret = CreateProcess(NULL, lpszCommandLine, NULL, NULL, TRUE,
			/*CREATE_SUSPENDED*/0, NULL, NULL, &si, &pi);
	if (!ret) {
		return GetLastError();
	}
	InjectDll(pi.hProcess);
	
//	ResumeThread(pi.hThread);
	CloseHandle(pi.hThread);
	
	WaitForSingleObject(pi.hProcess, INFINITE);
	GetExitCodeProcess(pi.hProcess, &exitcode);
	CloseHandle(pi.hProcess);
	return (int) exitcode;
}

void __cdecl mainCRTStartup(void)
{
	ExitProcess(main());
}
